/*
 * Created by Pavel Svoboda; Modified by Vladimir Bartik
 * xsvobo58 2MIT FIT VUT Brno
 */

package KnnMethod.Classes;

import java.util.ArrayList;

/**
 * Class, which computes and stores occurence counts of classified items 
 * and returns those ones with highest number of occurences. 
 */
public class KClasses {    
    private ArrayList<String> typClass = new ArrayList<String>();
    private ArrayList<Integer> numberClass= new ArrayList<Integer>();


    /**
     * Přidá novou hodnotu klasifikované třídy.
     * Pokud ještě nebyla definovaná přídá a nastaví počet na 1.
     * Pokud již byla vložena, provede inktement jejího počtu.
     * @param newClass název vkládané hodnoty pro inkrementaci
     */
    public void addClass (String newClass) {
        int nasel;
        nasel = this.typClass.indexOf(newClass);

        if (nasel == -1) {
            this.typClass.add(newClass);
            this.numberClass.add(1);
        }
        else {
            this.numberClass.set(nasel, this.numberClass.get(nasel)+1);
        }
    }

    /**
     * Method, which returns the most numerous classification class. 
     * In case of equality of two most numerous classes, the formerly found is returned.
     * @return name of the most numerous classificaton class
     */
    public String getKNNClass () {
        //prvni bude ten co se vrati
        String KNNClass = typClass.get(0);
        int pocet = numberClass.get(0);

        for (int i = 1; i < typClass.size(); i++) {
            if (numberClass.get(i) > pocet) {
                KNNClass = typClass.get(i);
                pocet = numberClass.get(i);
            }           
        }

        return KNNClass;
    }
}