/**
 * Created by Pavel Svoboda; Modified by Vladimir Bartik
 * xsvobo58 2MIT FIT VUT Brno
 */

package KnnMethod.Classes;

/**
 * Class, which serves for storing minimum a maximum value of all columns. 
 * Minimum and maximum value is used for normalization of an attribute into the interval [0..1].
 */
public class MinMax {
    private double min;
    private double max;

    /**
     * Constructor, which stores the minimum and maximum value of an attribute. 
     * @param minimum minimum value of an attribute
     * @param maximum maximum value of an attribute
     */
    public MinMax(double minimum, double maximum) {
        this.min = minimum;
        this.max = maximum;
    }

    /**
     * Empty constructor
     */
    public MinMax() {
    }

    /**
     * Returns the minimum value
     * @return minimum value
     */
    public double getMin () {
        return this.min;
    }

    /**
     * Sets the minimum value
     * @param newMin minimum value to store
     */
    public void setMin (double newMin) {
        this.min = newMin;
    }

    /**
     * Returns the maximum value
     * @return maximum value
     */
    public double getMax () {
        return this.max;
    }

    /**
     * Sets the maximum value
     * @param newMax maximum value to store
     */
    public void setMax (double newMax) {
        this.max = newMax;
    }
}