/**
 * Created by Pavel Svoboda; Modified by Vladimir Bartik
 * xsvobo58 2MIT FIT VUT Brno
 */

package KnnMethod.Classes;


import java.util.Vector;
import javax.swing.table.DefaultTableModel;


/**
 * Extension of the DefaultTableModel class - one method Vector getColumnIdentifiers()
 * added. This method id necessary for deleting the columns.
 */
public class MyDefaultTableModel extends DefaultTableModel {

    /**
     * Empty constructor
     */
    public MyDefaultTableModel() {
    }

    /**
     * Constructor, which enables adding columns with default names (taken from array "string").
     */
    public MyDefaultTableModel(Object[][] object, String[] string) {
        for (int i = 0; i < string.length; i++) {
            addColumn(string[i]);
        }
    }

    /**
     * Method, which extends the DefaultTableModel class.
     * It gets a vectors of all columns identifiers, necessary to delete the columns.
     * @return Vector of all columns identifiers
     */
    public Vector getColumnIdentifiers() {
        return  columnIdentifiers;
    }
}