/**
 * Created by Pavel Svoboda
 * xsvobo58 2MIT FIT VUT Brno
 */

package KnnMethod.UI;

import java.util.Vector;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JOptionPane;
import javax.swing.SpinnerNumberModel;

/**
 * Formulář, který obsahuje v sobě hlavní nastavení programu.
 */
public class Options extends javax.swing.JFrame {
    private Vector<String> separator = new Vector();
    private String selected = ";";
    private int zarazkaProcenta;
    private int zarazkaKNN;
    
    /** Creates new form Options */
    public Options() {
        separator.add(";");
        separator.add(",");
        initComponents();
        zarazkaProcenta = (Integer)jSpinnerZarazkaProcent.getValue();
        zarazkaKNN = 1000;
        jSpinnerZarazkaKNN.setValue(1000);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jComboBoxSeparator = new javax.swing.JComboBox();
        jButtonOK = new javax.swing.JButton();
        jButtonCancel = new javax.swing.JButton();
        jCheckBoxErrorMessages = new javax.swing.JCheckBox();
        jButtonNewSeparator = new javax.swing.JButton();
        jButtonDeleteSeparator = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jSpinnerZarazkaProcent = new javax.swing.JSpinner();
        jLabel2 = new javax.swing.JLabel();
        jSpinnerZarazkaKNN = new javax.swing.JSpinner();
        jLabel3 = new javax.swing.JLabel();

        setTitle("K-NN method - Options");
        setBackground(new java.awt.Color(27, 29, 41));
        setMinimumSize(new java.awt.Dimension(450, 200));
        setResizable(false);

        jPanel1.setBackground(new java.awt.Color(27, 29, 41));
        jPanel1.setForeground(new java.awt.Color(255, 255, 255));
        jPanel1.setMaximumSize(new java.awt.Dimension(450, 200));

        jComboBoxSeparator.setModel(new DefaultComboBoxModel(separator));

        jButtonOK.setText("OK");
        jButtonOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonOKActionPerformed(evt);
            }
        });

        jButtonCancel.setText("Cancel");
        jButtonCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCancelActionPerformed(evt);
            }
        });

        jCheckBoxErrorMessages.setBackground(new java.awt.Color(27, 29, 41));
        jCheckBoxErrorMessages.setForeground(new java.awt.Color(255, 255, 255));
        jCheckBoxErrorMessages.setText("Show error messages");

        jButtonNewSeparator.setText("New separator");
        jButtonNewSeparator.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonNewSeparatorActionPerformed(evt);
            }
        });

        jButtonDeleteSeparator.setText("Delete separator");
        jButtonDeleteSeparator.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonDeleteSeparatorActionPerformed(evt);
            }
        });

        jLabel1.setForeground(new java.awt.Color(255, 255, 255));
        jLabel1.setText("Select the separator:");

        jSpinnerZarazkaProcent.setModel(new javax.swing.SpinnerNumberModel(70, 0, 100, 1));

        jLabel2.setForeground(new java.awt.Color(255, 255, 255));
        jLabel2.setText("Minimal percentual breakpoint for automatic generator");

        jSpinnerZarazkaKNN.setModel(new javax.swing.SpinnerNumberModel(1, 1, 1000, 1));

        jLabel3.setForeground(new java.awt.Color(255, 255, 255));
        jLabel3.setText("Maximal number of 'k' value for automatic generator");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jCheckBoxErrorMessages)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jButtonNewSeparator, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jButtonDeleteSeparator, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addGap(18, 18, 18)
                        .addComponent(jLabel1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jComboBoxSeparator, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 68, Short.MAX_VALUE)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jButtonCancel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jButtonOK, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 81, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(jSpinnerZarazkaKNN, javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jSpinnerZarazkaProcent, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 46, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel3)
                            .addComponent(jLabel2))))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jButtonNewSeparator)
                            .addComponent(jLabel1)
                            .addComponent(jComboBoxSeparator, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButtonDeleteSeparator))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jButtonOK)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jButtonCancel)))
                .addGap(18, 18, 18)
                .addComponent(jCheckBoxErrorMessages)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jSpinnerZarazkaProcent, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jSpinnerZarazkaKNN, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel3))
                .addContainerGap(38, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButtonCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCancelActionPerformed
        jSpinnerZarazkaKNN.setValue(zarazkaKNN);
        jSpinnerZarazkaProcent.setValue(zarazkaProcenta);
        this.setVisible(false);
    }//GEN-LAST:event_jButtonCancelActionPerformed

    private void jButtonOKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonOKActionPerformed
        if (jComboBoxSeparator.getItemCount() == 0) {
            JOptionPane.showMessageDialog(null, "At least one separator must be created..");
        }
        else {
            selected = jComboBoxSeparator.getSelectedItem().toString();
            this.setVisible(false);
        }
        zarazkaProcenta = (Integer)jSpinnerZarazkaProcent.getValue();
        zarazkaKNN = (Integer)jSpinnerZarazkaKNN.getValue();
    }//GEN-LAST:event_jButtonOKActionPerformed

    private void jButtonNewSeparatorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonNewSeparatorActionPerformed
        String nodeName = JOptionPane.showInputDialog(null, "Enter the new separator:");
        separator.add(nodeName);
        jComboBoxSeparator.setModel(new DefaultComboBoxModel(separator));
        jComboBoxSeparator.setSelectedIndex(separator.size()-1);
    }//GEN-LAST:event_jButtonNewSeparatorActionPerformed

    private void jButtonDeleteSeparatorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonDeleteSeparatorActionPerformed
        int index = jComboBoxSeparator.getSelectedIndex();
        //pokud uz vsechny smazal
        if (index == -1) return;

        separator.removeElementAt(index);
        jComboBoxSeparator.setModel(new DefaultComboBoxModel(separator));        
    }//GEN-LAST:event_jButtonDeleteSeparatorActionPerformed

    /**
     * Funkce, která vrátí vybraný oddělovač jako řetězec.
     * @return vrátí vybraný oddělovač
     */
    public String getSeparator () {
        return selected;
    }

    /**
     * Získání první nastavené hodnoty zarážky v procentech,
     * která slouží k ukončení běhu generované hodnoty 'k'.
     * @return vrátí zvolenou zarážku
     */
    public int getZarazkuProcent () {
        return zarazkaProcenta;
    }

    /**
     * Funkce zda je zatrhnutý checkbox pro zobrazování zpráv v programu.
     * @return vrátí hodnotu True pokud ano nebo False pokud ne
     */
    public boolean isSetErrorShow() {
        return jCheckBoxErrorMessages.isSelected();
    }

    /**
     * Nastaví novou druhou zarážku, která slouží k ukončení běhu generování hodnoty 'k'.
     * @param zarazka nová vložená zarážka modelu
     */
    public void setZarazkaKNN (int zarazka) {
        if (zarazka>0) {            
            if (zarazka < zarazkaKNN) {
                jSpinnerZarazkaKNN.setModel(new SpinnerNumberModel(zarazka,1,zarazka,1));
                zarazkaKNN = zarazka;
            }
            jSpinnerZarazkaKNN.setModel(new SpinnerNumberModel(zarazkaKNN,1,zarazka,1));
        }
        if (zarazka == 0) {
            jSpinnerZarazkaKNN.setModel(new SpinnerNumberModel(1,1,1,1));
            zarazkaKNN = 1;
        }
    }

    /**
     * Získá druhé zarážky pro ukončení generované hodnoty 'k'.
     * @return hodnoty zarážky
     */
    public int getZarazkaKNN () {
        return zarazkaKNN;
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonCancel;
    private javax.swing.JButton jButtonDeleteSeparator;
    private javax.swing.JButton jButtonNewSeparator;
    private javax.swing.JButton jButtonOK;
    private javax.swing.JCheckBox jCheckBoxErrorMessages;
    private javax.swing.JComboBox jComboBoxSeparator;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JSpinner jSpinnerZarazkaKNN;
    private javax.swing.JSpinner jSpinnerZarazkaProcent;
    // End of variables declaration//GEN-END:variables

}
