/*
 * Created by Pavel Svoboda
 * xsvobo58 2MIT FIT VUT Brno
 */

package KnnMethod.UI;

import KnnMethod.Classes.Distance;
import KnnMethod.Classes.MyDefaultTableModel;
import KnnMethod.Classes.MinMax;
import KnnMethod.Classes.KClasses;
import java.awt.Color;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Random;
import java.util.Vector;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.TableColumn;
import javax.swing.table.TableModel;


/**
 * Hlavní uživatelské rozhraní.
 */
public class knnForm extends javax.swing.JFrame {

    /*[0] testovaci radek
        [0] trenovaci řadek
           [0] int    - index řádku do trenovací tabulky
           [1] double - vzdalenost
           [2] String - Trida
        ...
        [n] trenovacich řadků
      [1] testovaci radek
        [0] trenovacich
        ...
        [n]
      ...
      [n] testovacich radků
     */
    private ArrayList<ArrayList> poleVzdalenosti = new ArrayList<ArrayList>();

    //kazdy sloupec (atribut strnky) ma minimalni Text maximalni hodnotu
    private ArrayList<MinMax> poleMinMax = new ArrayList<MinMax> ();

    private String strSelectedTrain = "";
    private String strSelectedTypeTrain = "";
    private String strSelectedTest = "";
    private String strSelectedTypeTest = "";

    private boolean prepocitej = true;
    private boolean automat = false;
    //vector puvodni trid tabulky TESTING slouzi k restore data po jejich klasifikaci
    private Vector puvodniTridy = new Vector();

    //Option form ktery se inicializuje v konstruktoru..
    private Options optionsForm;
    private Statistics statisticForm;

    /** Creates new form knn */
    public knnForm() {
        initComponents();
        optionsForm = new Options();
        statisticForm = new Statistics();
        addListener(jTableDataTraining);
        addListener(jTableDataTesting);
    }
    
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanelForm = new javax.swing.JPanel();
        jPanelRightButtons = new javax.swing.JPanel();
        RecountIndicator = new javax.swing.JPanel();
        jButtonAddRow = new javax.swing.JButton();
        jButtonDeleteRow = new javax.swing.JButton();
        jButtonAddColumn = new javax.swing.JButton();
        jButtonDeleteColumn = new javax.swing.JButton();
        jButtonMoveData = new javax.swing.JButton();
        jButtonClose = new javax.swing.JButton();
        jButtonClear = new javax.swing.JButton();
        jButtonRandomMove = new javax.swing.JButton();
        jButtonDeleteAll = new javax.swing.JButton();
        jButtonStatistic = new javax.swing.JButton();
        jSpinnerRandomMove = new javax.swing.JSpinner();
        jLabelRandomMove = new javax.swing.JLabel();
        jButtonRecountAll = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jPanelHead = new javax.swing.JPanel();
        jButtonKNN = new javax.swing.JButton();
        jTabbedPane = new javax.swing.JTabbedPane();
        jPanelTraining = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTableDataTraining = new javax.swing.JTable();
        jScrollPane4 = new javax.swing.JScrollPane();
        jTableHeadTraining = new javax.swing.JTable();
        jPanelTesting = new javax.swing.JPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        jTableDataTesting = new javax.swing.JTable();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTableHeadTesting = new javax.swing.JTable();
        label1 = new java.awt.Label();
        textOutPut = new java.awt.TextArea();
        jSliderKNNValue = new javax.swing.JSlider();
        jLabelKNN = new javax.swing.JLabel();
        jButtonRestoreData = new javax.swing.JButton();
        jButtonAutomatic = new javax.swing.JButton();
        jMenuBar = new javax.swing.JMenuBar();
        jMenuFile = new javax.swing.JMenu();
        jMenuFileImport = new javax.swing.JMenu();
        jMenuImportTraining = new javax.swing.JMenuItem();
        jMenuImportTesting = new javax.swing.JMenuItem();
        jMenuFileExport = new javax.swing.JMenu();
        jMenuExportTraining = new javax.swing.JMenuItem();
        jMenuExportTesting = new javax.swing.JMenuItem();
        jMenuExportStatistics = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JSeparator();
        jMenuExit = new javax.swing.JMenuItem();
        jMenuTools = new javax.swing.JMenu();
        jMenuOptions = new javax.swing.JMenuItem();
        jMenuAbout = new javax.swing.JMenu();
        jMenuItemAbout = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("K-NN method"); // NOI18N
        setBackground(new java.awt.Color(27, 29, 41));
        setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        setMinimumSize(new java.awt.Dimension(1000, 650));

        jPanelForm.setBackground(new java.awt.Color(27, 29, 41));

        jPanelRightButtons.setBackground(new java.awt.Color(27, 29, 41));

        RecountIndicator.setBackground(new java.awt.Color(255, 0, 0));

        javax.swing.GroupLayout RecountIndicatorLayout = new javax.swing.GroupLayout(RecountIndicator);
        RecountIndicator.setLayout(RecountIndicatorLayout);
        RecountIndicatorLayout.setHorizontalGroup(
            RecountIndicatorLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 28, Short.MAX_VALUE)
        );
        RecountIndicatorLayout.setVerticalGroup(
            RecountIndicatorLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 15, Short.MAX_VALUE)
        );

        jButtonAddRow.setIcon(new javax.swing.ImageIcon(getClass().getResource("/KnnMethod/picture/button_plus.png"))); // NOI18N
        jButtonAddRow.setText("Add row");
        jButtonAddRow.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jButtonAddRow.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonAddRowActionPerformed(evt);
            }
        });

        jButtonDeleteRow.setIcon(new javax.swing.ImageIcon(getClass().getResource("/KnnMethod/picture/button_minus_a.png"))); // NOI18N
        jButtonDeleteRow.setText("Delete row");
        jButtonDeleteRow.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jButtonDeleteRow.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonDeleteRowActionPerformed(evt);
            }
        });

        jButtonAddColumn.setIcon(new javax.swing.ImageIcon(getClass().getResource("/KnnMethod/picture/button_plus.png"))); // NOI18N
        jButtonAddColumn.setText("Add column");
        jButtonAddColumn.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jButtonAddColumn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonAddColumnActionPerformed(evt);
            }
        });

        jButtonDeleteColumn.setIcon(new javax.swing.ImageIcon(getClass().getResource("/KnnMethod/picture/button_minus_a.png"))); // NOI18N
        jButtonDeleteColumn.setText("Delete column");
        jButtonDeleteColumn.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jButtonDeleteColumn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonDeleteColumnActionPerformed(evt);
            }
        });

        jButtonMoveData.setText("< Move data >");
        jButtonMoveData.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonMoveDataActionPerformed(evt);
            }
        });

        jButtonClose.setText("Close");
        jButtonClose.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButtonClose.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCloseActionPerformed(evt);
            }
        });

        jButtonClear.setIcon(new javax.swing.ImageIcon(getClass().getResource("/KnnMethod/picture/button_delete_a.png"))); // NOI18N
        jButtonClear.setText("Clear");
        jButtonClear.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jButtonClear.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonClearActionPerformed(evt);
            }
        });

        jButtonRandomMove.setText("Random move");
        jButtonRandomMove.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonRandomMoveActionPerformed(evt);
            }
        });

        jButtonDeleteAll.setIcon(new javax.swing.ImageIcon(getClass().getResource("/KnnMethod/picture/button_delete_a.png"))); // NOI18N
        jButtonDeleteAll.setText("Delete All");
        jButtonDeleteAll.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jButtonDeleteAll.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonDeleteAllActionPerformed(evt);
            }
        });

        jButtonStatistic.setText("Statistic");
        jButtonStatistic.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonStatisticActionPerformed(evt);
            }
        });

        jSpinnerRandomMove.setBackground(new java.awt.Color(27, 29, 41));
        jSpinnerRandomMove.setModel(new javax.swing.SpinnerNumberModel(1, 1, 99, 1));

        jLabelRandomMove.setBackground(new java.awt.Color(27, 29, 41));
        jLabelRandomMove.setForeground(new java.awt.Color(255, 255, 255));
        jLabelRandomMove.setText("% to move");

        jButtonRecountAll.setText("Recount All");
        jButtonRecountAll.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonRecountAllActionPerformed(evt);
            }
        });

        jLabel1.setForeground(new java.awt.Color(255, 255, 255));
        jLabel1.setText("Recount distance:");

        javax.swing.GroupLayout jPanelRightButtonsLayout = new javax.swing.GroupLayout(jPanelRightButtons);
        jPanelRightButtons.setLayout(jPanelRightButtonsLayout);
        jPanelRightButtonsLayout.setHorizontalGroup(
            jPanelRightButtonsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelRightButtonsLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelRightButtonsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jButtonDeleteColumn, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanelRightButtonsLayout.createSequentialGroup()
                        .addComponent(jSpinnerRandomMove, javax.swing.GroupLayout.PREFERRED_SIZE, 48, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jLabelRandomMove))
                    .addComponent(jButtonAddRow, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jButtonDeleteRow, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jButtonAddColumn, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jButtonDeleteAll, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jButtonClear, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jButtonMoveData, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jButtonRandomMove, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jButtonClose, javax.swing.GroupLayout.DEFAULT_SIZE, 119, Short.MAX_VALUE)
                    .addGroup(jPanelRightButtonsLayout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(RecountIndicator, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jButtonStatistic, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jButtonRecountAll, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanelRightButtonsLayout.setVerticalGroup(
            jPanelRightButtonsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelRightButtonsLayout.createSequentialGroup()
                .addGap(20, 20, 20)
                .addGroup(jPanelRightButtonsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1)
                    .addComponent(RecountIndicator, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(26, 26, 26)
                .addComponent(jButtonAddRow)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButtonDeleteRow)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jButtonAddColumn)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButtonDeleteColumn)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jButtonDeleteAll)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButtonClear)
                .addGap(18, 18, 18)
                .addComponent(jButtonMoveData)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButtonRandomMove)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanelRightButtonsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jSpinnerRandomMove, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabelRandomMove))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jButtonStatistic)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButtonRecountAll)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 72, Short.MAX_VALUE)
                .addComponent(jButtonClose, javax.swing.GroupLayout.PREFERRED_SIZE, 62, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        jPanelHead.setBackground(new java.awt.Color(27, 29, 41));
        jPanelHead.setAlignmentX(0.0F);
        jPanelHead.setAlignmentY(0.0F);

        jButtonKNN.setText("KNN");
        jButtonKNN.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonKNNActionPerformed(evt);
            }
        });

        jTabbedPane.setAlignmentX(0.0F);
        jTabbedPane.setAlignmentY(0.0F);
        jTabbedPane.setMinimumSize(new java.awt.Dimension(782, 357));

        jPanelTraining.setAlignmentX(0.0F);
        jPanelTraining.setAlignmentY(0.0F);

        jScrollPane1.setAlignmentX(0.0F);
        jScrollPane1.setAlignmentY(0.0F);

        jTableDataTraining.setModel(new MyDefaultTableModel());
        jTableDataTraining.setAlignmentX(0.0F);
        jTableDataTraining.setAlignmentY(0.0F);
        jScrollPane1.setViewportView(jTableDataTraining);

        jScrollPane4.setHorizontalScrollBarPolicy(javax.swing.ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
        jScrollPane4.setVerticalScrollBarPolicy(javax.swing.ScrollPaneConstants.VERTICAL_SCROLLBAR_NEVER);

        jTableHeadTraining.setModel(new MyDefaultTableModel());
        jTableHeadTraining.setAlignmentX(0.0F);
        jTableHeadTraining.setAlignmentY(0.0F);
        jTableHeadTraining.setEnabled(false);
        jScrollPane4.setViewportView(jTableHeadTraining);

        javax.swing.GroupLayout jPanelTrainingLayout = new javax.swing.GroupLayout(jPanelTraining);
        jPanelTraining.setLayout(jPanelTrainingLayout);
        jPanelTrainingLayout.setHorizontalGroup(
            jPanelTrainingLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanelTrainingLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelTrainingLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPane4, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 763, Short.MAX_VALUE)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 763, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanelTrainingLayout.setVerticalGroup(
            jPanelTrainingLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelTrainingLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane4, javax.swing.GroupLayout.PREFERRED_SIZE, 42, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 276, Short.MAX_VALUE)
                .addContainerGap())
        );

        jTabbedPane.addTab("Training data", jPanelTraining);

        jPanelTesting.setAlignmentX(0.0F);
        jPanelTesting.setAlignmentY(0.0F);

        jScrollPane3.setAlignmentX(0.0F);
        jScrollPane3.setAlignmentY(0.0F);

        jTableDataTesting.setModel(new MyDefaultTableModel());
        jTableDataTesting.setAlignmentX(0.0F);
        jTableDataTesting.setAlignmentY(0.0F);
        jScrollPane3.setViewportView(jTableDataTesting);

        jScrollPane2.setHorizontalScrollBarPolicy(javax.swing.ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
        jScrollPane2.setVerticalScrollBarPolicy(javax.swing.ScrollPaneConstants.VERTICAL_SCROLLBAR_NEVER);

        jTableHeadTesting.setModel(new MyDefaultTableModel());
        jTableHeadTesting.setAlignmentX(0.0F);
        jTableHeadTesting.setAlignmentY(0.0F);
        jTableHeadTesting.setEnabled(false);
        jScrollPane2.setViewportView(jTableHeadTesting);

        javax.swing.GroupLayout jPanelTestingLayout = new javax.swing.GroupLayout(jPanelTesting);
        jPanelTesting.setLayout(jPanelTestingLayout);
        jPanelTestingLayout.setHorizontalGroup(
            jPanelTestingLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanelTestingLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelTestingLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 763, Short.MAX_VALUE)
                    .addComponent(jScrollPane3, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 763, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanelTestingLayout.setVerticalGroup(
            jPanelTestingLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelTestingLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 42, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane3, javax.swing.GroupLayout.DEFAULT_SIZE, 276, Short.MAX_VALUE)
                .addContainerGap())
        );

        jTabbedPane.addTab("Testing data", jPanelTesting);

        label1.setFont(new java.awt.Font("Dialog", 1, 12));
        label1.setForeground(new java.awt.Color(240, 240, 240));
        label1.setText("System output:");

        textOutPut.setEditable(false);
        textOutPut.setFont(new java.awt.Font("Dialog", 0, 10));

        jSliderKNNValue.setBackground(new java.awt.Color(27, 29, 41));
        jSliderKNNValue.setMinimum(1);
        jSliderKNNValue.setValue(1);
        jSliderKNNValue.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSliderKNNValueStateChanged(evt);
            }
        });

        jLabelKNN.setBackground(new java.awt.Color(0, 0, 0));
        jLabelKNN.setForeground(new java.awt.Color(255, 255, 255));
        jLabelKNN.setText("1");

        jButtonRestoreData.setText("Restore");
        jButtonRestoreData.setEnabled(false);
        jButtonRestoreData.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonRestoreDataActionPerformed(evt);
            }
        });

        jButtonAutomatic.setText("Automatic generator");
        jButtonAutomatic.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonAutomaticActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanelHeadLayout = new javax.swing.GroupLayout(jPanelHead);
        jPanelHead.setLayout(jPanelHeadLayout);
        jPanelHeadLayout.setHorizontalGroup(
            jPanelHeadLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanelHeadLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelHeadLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(textOutPut, javax.swing.GroupLayout.DEFAULT_SIZE, 788, Short.MAX_VALUE)
                    .addComponent(jTabbedPane, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 788, Short.MAX_VALUE)
                    .addComponent(label1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(jPanelHeadLayout.createSequentialGroup()
                        .addComponent(jButtonAutomatic)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButtonRestoreData)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButtonKNN)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jSliderKNNValue, javax.swing.GroupLayout.DEFAULT_SIZE, 407, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jLabelKNN, javax.swing.GroupLayout.PREFERRED_SIZE, 94, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        jPanelHeadLayout.setVerticalGroup(
            jPanelHeadLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelHeadLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelHeadLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanelHeadLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jButtonRestoreData)
                        .addComponent(jButtonAutomatic))
                    .addGroup(jPanelHeadLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(jPanelHeadLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jButtonKNN)
                            .addComponent(jLabelKNN))
                        .addComponent(jSliderKNNValue, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jTabbedPane, javax.swing.GroupLayout.DEFAULT_SIZE, 374, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(label1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(textOutPut, javax.swing.GroupLayout.PREFERRED_SIZE, 90, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        javax.swing.GroupLayout jPanelFormLayout = new javax.swing.GroupLayout(jPanelForm);
        jPanelForm.setLayout(jPanelFormLayout);
        jPanelFormLayout.setHorizontalGroup(
            jPanelFormLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelFormLayout.createSequentialGroup()
                .addComponent(jPanelHead, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanelRightButtons, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        jPanelFormLayout.setVerticalGroup(
            jPanelFormLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanelFormLayout.createSequentialGroup()
                .addGroup(jPanelFormLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jPanelRightButtons, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanelHead, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );

        jMenuBar.setAlignmentX(0.0F);

        jMenuFile.setText("File");

        jMenuFileImport.setText("Import");

        jMenuImportTraining.setText("Training data");
        jMenuImportTraining.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuImportTrainingActionPerformed(evt);
            }
        });
        jMenuFileImport.add(jMenuImportTraining);

        jMenuImportTesting.setText("Testing data");
        jMenuImportTesting.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuImportTestingActionPerformed(evt);
            }
        });
        jMenuFileImport.add(jMenuImportTesting);

        jMenuFile.add(jMenuFileImport);

        jMenuFileExport.setText("Export");

        jMenuExportTraining.setText("Training data");
        jMenuExportTraining.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuExportTrainingActionPerformed(evt);
            }
        });
        jMenuFileExport.add(jMenuExportTraining);

        jMenuExportTesting.setText("Testing data");
        jMenuExportTesting.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuExportTestingActionPerformed(evt);
            }
        });
        jMenuFileExport.add(jMenuExportTesting);

        jMenuExportStatistics.setText("Statistics");
        jMenuExportStatistics.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuExportStatisticsActionPerformed(evt);
            }
        });
        jMenuFileExport.add(jMenuExportStatistics);

        jMenuFile.add(jMenuFileExport);
        jMenuFile.add(jSeparator1);

        jMenuExit.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_X, java.awt.event.InputEvent.CTRL_MASK));
        jMenuExit.setText("Exit");
        jMenuExit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuExitActionPerformed(evt);
            }
        });
        jMenuFile.add(jMenuExit);

        jMenuBar.add(jMenuFile);

        jMenuTools.setText("Tools");

        jMenuOptions.setText("Options");
        jMenuOptions.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuOptionsActionPerformed(evt);
            }
        });
        jMenuTools.add(jMenuOptions);

        jMenuBar.add(jMenuTools);

        jMenuAbout.setText("About ");

        jMenuItemAbout.setText("About");
        jMenuItemAbout.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemAboutActionPerformed(evt);
            }
        });
        jMenuAbout.add(jMenuItemAbout);

        jMenuBar.add(jMenuAbout);

        setJMenuBar(jMenuBar);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanelForm, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanelForm, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jMenuExitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuExitActionPerformed
    exitForm ();
}//GEN-LAST:event_jMenuExitActionPerformed


    private void addListener (JTable tabulka) {
        //Listener obsahuje v sobě equals metodu zda je jTableData Testing vs Train...
        tabulka.getModel().addTableModelListener(new ListenerTableChanged());
        //zachytává změny v řádcích, pokud změni řádek i sloupec budou 2 události (redundance)
        tabulka.getSelectionModel().addListSelectionListener(new RowColumnListener(tabulka));
        //zachytává změny ve sloupci, pokud změni řádek i sloupec budou 2 události (redundance)
        tabulka.getColumnModel().getSelectionModel().addListSelectionListener(new RowColumnListener(tabulka));
    }

    private class ListenerTableChanged implements TableModelListener {
        public void tableChanged(TableModelEvent e) {
            int row = e.getFirstRow();
            int column = e.getColumn();
            TableModel model = (TableModel)e.getSource();
            //String columnName = model.getColumnName(column);
            // jen pokud je tabulka prazdna (nic v ni neni dal delete nebo je prazdna)            
            if(model.getRowCount() <= 0 || model.getColumnCount() <= 0 || row < 0 || column <0) {
                if(column >= 0) textOutPut.setText(textOutPut.getText() + "\nRETURN from Listener: ROW:" + row + " column: " + column + " model row: " + model.getRowCount() + " model column: " + model.getColumnCount());
                return;
            }

            //urychleni, pokud je automat nevypisuj hlasky
            if (automat) return;

            Object data = model.getValueAt(row, column);            

            String strSelected = "";
            String strSelectedType = "";

            //kontrola na co jsem kliknul, zda v TEST nebo TRAIN
            if(model.equals(jTableDataTraining.getModel())) {
                textOutPut.setText(textOutPut.getText() + "\nTRAIN table - row: " + row + ", column: " + column + ";\t");
                strSelected = strSelectedTrain;
                strSelectedType = strSelectedTypeTrain;
            }
            else if(model.equals(jTableDataTesting.getModel()))  {
                textOutPut.setText(textOutPut.getText() + "\nTEST table - row: " + row + ", column: " + column + ";\t");
                strSelected = strSelectedTest;
                strSelectedType = strSelectedTypeTest;
            }

            if (strSelected.isEmpty() && strSelectedType.isEmpty()) {
                return;
            }

            //Pokud jsem EDITOVAL nejaky prvek v tabulce je nutne prepocitat data
            prepocitej = true;
            RecountIndicator.setBackground(new Color(255, 0, 0)); //cervena

            String newType = "";
            try {
                //zkontroluji, zda na radku i, sloupci j je DOUBLE
                Double.parseDouble(data.toString());
                newType = "Number";
            }
            catch(NumberFormatException ex) {
                newType = "Text";
            }

            //pokud novy zadany nazev souhlasi s typem v hlavicce
            if (strSelectedType.equals(newType)) {
                textOutPut.setText(textOutPut.getText() + "\n  Old data: " + strSelected + " \tNew data: " + data);
                textOutPut.setText(textOutPut.getText() + "\n  Old Type: " + strSelectedType + " \tNew Type: " + newType);

                //prepocitam MIN MAX jen pro NUMBER!!!
                if(newType.equals("Number")) {
                    textOutPut.setText(textOutPut.getText() + "\n  Recounting MIN and MAX only for number");
                    if(((model.equals(jTableDataTraining.getModel())))) recountFunction(jTableDataTraining);
                    else if(model.equals(jTableDataTesting.getModel())) recountFunction(jTableDataTesting);
                }
            }
            else {
                if (newType.equals("Number")) {
                    textOutPut.setText(textOutPut.getText() + "\n    Different - automat checking...");
                    if(((model.equals(jTableDataTraining.getModel())))) getAndSetHeadType(jTableDataTraining, jTableHeadTraining);
                    else if(model.equals(jTableDataTesting.getModel())) getAndSetHeadType(jTableDataTesting, jTableHeadTesting);
                    textOutPut.setText(textOutPut.getText() + "\n    Type will be changed (automatic)...");
                }
                else if (newType.equals("Text")) {
                    textOutPut.setText(textOutPut.getText() + "\n    Different - error message..");
                    int question = -1;

                    if (optionsForm.isSetErrorShow()) {
                        question = JOptionPane.showConfirmDialog(null,
                        "Column is type of " + strSelectedType + " and you put type " + newType + "\nChange: " + strSelected + " -> " + data + "!\nDo you want change type of column from 'number' to 'text'?",
                        "ERROR",
                        JOptionPane.OK_CANCEL_OPTION,
                        JOptionPane.ERROR_MESSAGE);
                    }

                    if(question == JOptionPane.YES_OPTION || !optionsForm.isSetErrorShow()) {
                        textOutPut.setText(textOutPut.getText() + "\n    User chose YES or by default..");
                        if(((model.equals(jTableDataTraining.getModel())))) getAndSetHeadType(jTableDataTraining, jTableHeadTraining);
                        else if(model.equals(jTableDataTesting.getModel())) getAndSetHeadType(jTableDataTesting, jTableHeadTesting);
                    }
                    else {
                        //vratim zpet puvodni cislo (Text zahodim)
                        model.setValueAt(strSelected, row, column);
                        textOutPut.setText(textOutPut.getText() + "\n    Getting back previous value..");
                    }
                }
            }

            textOutPut.setCaretPosition(textOutPut.getText().length());
        }
    }

    private class RowColumnListener implements ListSelectionListener {
        JTable tabulka;
        String vybral;
        String typ;

        private RowColumnListener(JTable t) {
            this.tabulka = t;
        }

        public void valueChanged(ListSelectionEvent event) {
            if (event.getValueIsAdjusting()) {
                return;
            }
            int row = this.tabulka.getSelectionModel().getLeadSelectionIndex();
            int column = this.tabulka.getColumnModel().getSelectionModel().getLeadSelectionIndex();

            // jen pokud je tabulka prazdna (nic v ni neni dal delete nebo je prazdna)
            if(tabulka.getRowCount() == 0 || tabulka.getColumnCount() == 0) {
                return;
            }

            //osetreni bugu pri vkladani noveho sloupce HNED po editaci!!!!
            if (row == -1 || column == -1) {
                return;
            }

            /// Zachytavani HODNOT
            if (tabulka.equals(jTableDataTraining)) {                
                strSelectedTrain = this.tabulka.getValueAt(row, column).toString();
                strSelectedTypeTrain = jTableHeadTraining.getValueAt(0, column).toString();
                vybral = strSelectedTrain;
                typ = strSelectedTypeTrain;
            }
            else if(tabulka.equals(jTableDataTesting)) {
                strSelectedTest = this.tabulka.getValueAt(row, column).toString();
                strSelectedTypeTest = jTableHeadTesting.getValueAt(0, column).toString();
                vybral = strSelectedTest;
                typ = strSelectedTypeTest;
            }            

            outputSelection(row, column, vybral, typ);
        }
    }

    private void outputSelection(int row, int column, String vybral, String typ) {
        textOutPut.setText(textOutPut.getText() + "\nRow: " + row + "\t\tColumn: " + column);
        textOutPut.setText(textOutPut.getText() + "\t\tData: " + vybral + "\t\tType: " + typ);
        if (!poleMinMax.isEmpty()) {
            textOutPut.setText(textOutPut.getText() + "\t\tMINIMUM: " + poleMinMax.get(column).getMin());
            textOutPut.setText(textOutPut.getText() + "\t\tMAXIMUM: " + poleMinMax.get(column).getMax());
        }
        textOutPut.setCaretPosition(textOutPut.getText().length());
    }

/*
 * Vraci -1 pokud doslo k zruseni importovani
 * vraci 0 pokud importovani probehlo úspěšně
 */
private void importToTable(JTable tabHead, JTable tabData){
    JFileChooser fc = new JFileChooser ();
    fc.setDialogTitle ("Open File");

    // Now open chooser
    int result = fc.showOpenDialog (this);

    if (result == JFileChooser.CANCEL_OPTION) {
      textOutPut.setText(textOutPut.getText() + "\nCancel");      
    }
    else if (result == JFileChooser.APPROVE_OPTION) {
        File fFile = fc.getSelectedFile();
        if(fFile.exists()) {
            // ctu data
            parserFile(fFile, tabHead, tabData);
            textOutPut.setText(textOutPut.getText() + "\nParser file ready");

            //Nastavim aktivni TAB
            if(((tabData.equals(jTableDataTraining)))) jTabbedPane.setSelectedIndex(0);
            else if(tabData.equals(jTableDataTesting)) jTabbedPane.setSelectedIndex(1);
            
            recountFunction(tabData);

            //po importovani je nutne prepocitat vstupni data
            prepocitej = true;
            RecountIndicator.setBackground(new Color(255, 0, 0)); //cervena
      }      
    } else {
      textOutPut.setText(textOutPut.getText() + "\nWrong data");      
    }
    textOutPut.setCaretPosition(textOutPut.getText().length());
}

private void parserFile(File file, JTable tabHead, JTable tabData) {
    MyDefaultTableModel tabModelHead = (MyDefaultTableModel)tabHead.getModel();
    MyDefaultTableModel tabModelData = (MyDefaultTableModel)tabData.getModel();


    boolean Header = false;
    int question = JOptionPane.showConfirmDialog(null,
        "Does imported data have a header?",
        "Question",
        JOptionPane.YES_NO_OPTION,
        JOptionPane.QUESTION_MESSAGE);
    if (question == JOptionPane.YES_OPTION) Header=true;

    try {
      FileReader soubor = new FileReader(file);
      BufferedReader in = new BufferedReader(soubor);

      int nLines = 0;
      while (true) {
        String line = in.readLine();
        if (line == null)
            break;

        // Split the input line into XY tokens
        String separator = optionsForm.getSeparator();
        String[] tokens = line.split(separator);


        if (nLines == 0 && Header == true) {
            //pokud jsem jeste nic nenacetl
            if (tabData.getColumnCount() == 0) {
                for (int i = 0; i < tokens.length ; i++) {
                    tabModelData.addColumn(tokens[i]);
                    tabModelHead.addColumn(tokens[i]);
                }
            }
            // 1 MOZNOST tabulka dat je MENSI nez importovane data..
            else if (tabData.getColumnCount() < tokens.length && tabData.getColumnCount() > 0) {
                //musim pridat k jiz importovanym radkum nejaky text,,, IMPORT je VETSI nez moje data
                for (int i = tabData.getColumnCount(); i < tokens.length ; i++) {
                    //zavola addColumn (Nazev)
                    addColumnFunction(tabData, tabHead, tokens[i]);
                }
            }

            nLines++;
            continue;
        }
        else if  (nLines == 0 && Header == false && tokens.length > tabData.getColumnCount()) {
            //pokud jsem jeste nic nenacetl
            if (tabData.getColumnCount() == 0) {
                for (int i = 0; i < tokens.length; i++) {
                    //tokens[0];
                    tabModelData.addColumn("Column " + (i));
                    tabModelHead.addColumn("Column " + (i));
                }
            }
            else if (tabData.getColumnCount() < tokens.length && tabData.getColumnCount() > 0) {
                //musim pridat k jiz importovanym radkum nejaky text,,, IMPORT je VETSI nez moje data
                for (int i = tabData.getColumnCount(); i < tokens.length ; i++) {
                    //zavola addColumn (Nazev)
                    addColumnFunction(tabData, tabHead, "Column " + i);
                }
            }
        }
        
        /// 2 MOZNOST!!!! pridat pokud je mensi IMPORT!!!!
        if (tokens.length < tabData.getColumnCount()) {
            Vector a = new Vector();
            for (int i = 0; i < tokens.length; i++) {
                a.add(tokens[i]);
            }
            for (int i = tokens.length; i < tabData.getColumnCount(); i++) {
                if (tabHead.getValueAt(0, i).equals("Number")) {
                    a.add(0); // Doplnim radek NULAMA kdyz sNumber
                }
                else {
                    a.add("Text"); // Doplnim radek Textem kdyz Text
                }

            }
            tabModelData.addRow(a);

        }
        else {
            //PRIDA KLASIKA radek
            tabModelData.addRow(tokens);
        }

        nLines++;
      } //while
      soubor.close();
    } catch (IOException e) {
        return;
    }
    return;
} // parserFile

private void getNewMinMax() {
    poleMinMax.clear();
    getMinMax(jTableDataTesting);
    getMinMax(jTableDataTraining);
}

private void getMinMax(JTable tabulka) {
    double newMin, newMax;
    MinMax minmax;
    for (int j = 0; j < tabulka.getColumnCount() && tabulka.getRowCount() > 0; j++) {
        try {
            //ulozim prvni lepsi MIN Text MAX (i pak bude = 1 jelikoz prvni radek preskocim)
            String sX = tabulka.getValueAt(0, j).toString(); // 0  jelikoz beru prvni zaznam
            double x = Double.parseDouble(sX);            

            //pridam prvni sloupce pokud jsou definovane, jen nepridavam jen kontroluji MIN Text MAX
            if (poleMinMax.size() < tabulka.getColumnCount()) {
                minmax = new MinMax(x, x);
                poleMinMax.add(minmax);
            }
            else {
                minmax = poleMinMax.get(j);
            }
            
            // co když pak jeste v cislech bude TEXT???? :-/
            // beru od 0 jelikož pokud jedu po NEKOLITATE minMax, tak je treba zkontrolovat i prvni zaznam
            // predtim se prvni zaznam nastavoval na min/max Text proto se preskocil Text tedy bylo i = 1;
            for (int i = 0; i < tabulka.getRowCount(); i++) {
                sX = tabulka.getValueAt(i, j).toString();
                x = Double.parseDouble(sX);
                
                newMin = getMinimum(minmax.getMin(), x);
                newMax = getMaximum(minmax.getMax(), x);

                if(newMin < minmax.getMin()) {
                    minmax.setMin(newMin);
                    poleMinMax.set(j,minmax);
                }
                if(newMax > minmax.getMax()) {
                    minmax.setMax(newMax);
                    poleMinMax.set(j, minmax);
                }
            }
        } catch(NumberFormatException e) {
            //pridam prvni sloupce pokud jsou definovane, jen nepridavam jen kontroluji MIN Text MAX
            if (poleMinMax.size() < tabulka.getColumnCount()) poleMinMax.add(new MinMax(0, 1));
        }
    }
}

private void getAndSetHeadType (JTable tabData, JTable tabHead) {
    String obsah = "Text";
    //[0] Text, [1] string ..
    ArrayList<String> poleTypu = new ArrayList<String> ();
        
    for (int j = 0; j < tabData.getColumnCount(); j++){
        for (int i = 0; i < tabData.getRowCount(); i++) {
            try {
                //zkontroluji, zda na radku i, sloupci j je DOUBLE
                Double.parseDouble(tabData.getValueAt(i, j).toString());
                obsah = "Number";
            }
            catch(NumberFormatException e) {
                obsah = "Text";
                break;
            }
        }
        poleTypu.add(obsah);
    }

    MyDefaultTableModel tabModelHead = (MyDefaultTableModel)tabHead.getModel();
    int delka = tabModelHead.getColumnCount();
    String dataHead[] = new String[delka];

    //vymazu to co tam bylo Text/Number / Number atd..
    tabModelHead.getDataVector().clear();

    for (int i = 0; i < delka; i++) {
        dataHead[i] = poleTypu.get(i);
    }
    tabModelHead.addRow(dataHead);

}

private double getMinimum (double A, double B) {
    if (A > B) return B;
    else return A;
}

private double getMaximum (double A, double B) {
    if (A >= B) return A;
    else return B;
}


private void deleteALL (boolean dotaz) {
    int question = -1;
    JTable tabData = null;
    JTable tabHead = null;
    int aktivni = jTabbedPane.getSelectedIndex();
    if (aktivni == 0) {
        tabData = jTableDataTraining;
        tabHead = jTableHeadTraining;
    }
    else if (aktivni == 1) {
        tabData = jTableDataTesting;
        tabHead = jTableHeadTesting;
    }
    if (tabData == null || tabHead == null) return;

    if(dotaz && optionsForm.isSetErrorShow()) {
        question = JOptionPane.showConfirmDialog(null,
            "Do you want to delete all data?",
            "Question",
            JOptionPane.YES_NO_OPTION,
            JOptionPane.QUESTION_MESSAGE);
    }

    if (question == JOptionPane.YES_OPTION || !dotaz || !optionsForm.isSetErrorShow()) {
        if (dotaz && optionsForm.isSetErrorShow()) textOutPut.setText(textOutPut.getText() + "\nUser chose YES to delete all data..");
        
        //vytvorim si prazdny model
        MyDefaultTableModel jTableModelData = new MyDefaultTableModel();
        MyDefaultTableModel jTableModelHead = new MyDefaultTableModel();

        tabData.clearSelection();
        ((MyDefaultTableModel)tabData.getModel()).getDataVector().clear();
        tabData.setModel(jTableModelData);

        tabHead.clearSelection();
        ((MyDefaultTableModel)tabHead.getModel()).getDataVector().clear();
        tabHead.setModel(jTableModelHead);

        //pridam naslouchac, jelikož Model ho smazal..
        tabData.getModel().addTableModelListener(new ListenerTableChanged());

        textOutPut.setText("Table is empty.");

        recountFunction(tabData);
    }
    else if (question == JOptionPane.NO_OPTION) {
        textOutPut.setText(textOutPut.getText() + "\nUser chose NO not to delete all data..");
    }
    textOutPut.setCaretPosition(textOutPut.getText().length());
}

private void clearALL (boolean dotaz) {
    int question = -1;
    JTable tabData = null;
    int aktivni = jTabbedPane.getSelectedIndex();
    if (aktivni == 0) {
        tabData = jTableDataTraining;
    }
    else if (aktivni == 1) {
        tabData = jTableDataTesting;
    }
    if (tabData == null) return;

    if (dotaz && optionsForm.isSetErrorShow()) {
        question = JOptionPane.showConfirmDialog(null,
            "Do you want to clear all data?",
            "Question",
            JOptionPane.YES_NO_OPTION,
            JOptionPane.QUESTION_MESSAGE);
    }
    if (question == JOptionPane.YES_OPTION || !dotaz || !optionsForm.isSetErrorShow()) {
        if (dotaz && optionsForm.isSetErrorShow()) textOutPut.setText(textOutPut.getText() + "\nUser chose YES to clear data..");
        ((MyDefaultTableModel)tabData.getModel()).getDataVector().clear();
        ((MyDefaultTableModel)tabData.getModel()).fireTableDataChanged();
        textOutPut.setText(textOutPut.getText() + "\nTable is empty.");

        recountFunction(tabData);
    }
    else if (question == JOptionPane.NO_OPTION){
      textOutPut.setText(textOutPut.getText() + "\nUser chose NO not to clear data..");
    }
    textOutPut.setCaretPosition(textOutPut.getText().length());
}

private void jSliderKNNValueStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSliderKNNValueStateChanged
    jLabelKNN.setText(Integer.toString(jSliderKNNValue.getValue()));
}//GEN-LAST:event_jSliderKNNValueStateChanged

private void setSliderMaxValue () {
    jSliderKNNValue.setMaximum(jTableDataTraining.getRowCount());
    jSliderKNNValue.setMinimum(1);
    jLabelKNN.setText(Integer.toString(jSliderKNNValue.getValue()));
}

private void jButtonClearActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonClearActionPerformed
    if (jTableDataTraining.getRowCount() >= 1 || jTableDataTesting.getRowCount() >= 1) {
        clearALL (true);
    }            
}//GEN-LAST:event_jButtonClearActionPerformed

private void jButtonDeleteAllActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonDeleteAllActionPerformed
    if (jTableDataTraining.getColumnCount() >= 1 || jTableDataTesting.getColumnCount() >= 1) {
        deleteALL (true);
    }
}//GEN-LAST:event_jButtonDeleteAllActionPerformed

private void jMenuImportTrainingActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuImportTrainingActionPerformed
    importToTable(jTableHeadTraining, jTableDataTraining);
}//GEN-LAST:event_jMenuImportTrainingActionPerformed

private void jButtonCloseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCloseActionPerformed
    exitForm();
}//GEN-LAST:event_jButtonCloseActionPerformed

private void jMenuImportTestingActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuImportTestingActionPerformed
    importToTable(jTableHeadTesting, jTableDataTesting);
}//GEN-LAST:event_jMenuImportTestingActionPerformed

private void jButtonAutomaticActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonAutomaticActionPerformed
    boolean vporadku = compareColumnType();
    if (vporadku) {
        automat = true;
        float procentoUspesnosti = 100;
        int pocetChyb;
        int KNN = 1;
        textOutPut.setText("Computing started until breakpoint: " + optionsForm.getZarazkuProcent() + " or maximal 'k' value: " + optionsForm.getZarazkaKNN());


        //opakuje po PROCENTA nebo po zadanou hodnotu
        while (procentoUspesnosti >= optionsForm.getZarazkuProcent() && KNN <= optionsForm.getZarazkaKNN()) {
            jSliderKNNValue.setValue(KNN);            
            pocetChyb = getKNNfunction();
            procentoUspesnosti = (float) (100.00 - (100.00*(pocetChyb)/jTableDataTesting.getRowCount()));
       /*     textOutPut.setText(textOutPut.getText() + "\nKLASIFIKACE pro K = "+jSliderKNNValue.getValue());
            textOutPut.setText(textOutPut.getText() + "\n\tPocet chyb: " + pocetChyb);
            textOutPut.setText(textOutPut.getText() + "\n\tPocet radku: " + jTableDataTesting.getRowCount());*/
            //textOutPut.setText(textOutPut.getText() + "\nK = "+ KNN + ", percentual success = " + procentoUspesnosti);
            KNN++;
        }
        textOutPut.setText(textOutPut.getText() + "\nComputing finished..");
        textOutPut.setCaretPosition(textOutPut.getText().length());
        statisticForm.setLocationRelativeTo(null);
        statisticForm.setVisible(true);
        automat= false;
    }
}//GEN-LAST:event_jButtonAutomaticActionPerformed

private void jButtonKNNActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonKNNActionPerformed
    int chyba = getKNNfunction ();
    textOutPut.setCaretPosition(textOutPut.getText().length());
    if (chyba != -1) {
        statisticForm.setLocationRelativeTo(null);
        statisticForm.setVisible(true);
    }
}//GEN-LAST:event_jButtonKNNActionPerformed

//vraci -1 pokud bylo neco v neporadku..
private int getKNNfunction () {
    strSelectedTest = "";
    strSelectedTypeTest = "";
    int pocetChyb = -1;
    boolean vporadku = compareColumnType();

    //provadim jen pokud jsou data vporadku (sloupce, typy se rovnaji)
    if (vporadku) {
        jTabbedPane.setSelectedIndex(1);
        if (!automat) textOutPut.setText("Computing started..");

        //funkce na obnoveni hodnot - TRUE protoze chci zobrazovat hlasky => neni automat..
        if (automat) restoreDataFunction(false);
        else restoreDataFunction(true);

        //JEN POKUD NECO ZMENIL v tabulce, tak znovu prepocitam.. jinak muzu generovat tridy HNED!!!
        if(prepocitej) {
            recountFunction(jTableDataTesting);
                textOutPut.setText(textOutPut.getText() + " - testing table..");
            recountFunction(jTableDataTraining);
                textOutPut.setText(textOutPut.getText() + " - training table..");                
                textOutPut.setText(textOutPut.getText() + "\nComputing of distances... ");
                //DLOUHY VYPOCET!!! Proto byl nastaven caret aby uzivatel vedel ze se pocita
                textOutPut.setCaretPosition(textOutPut.getText().length());

            getVzdalenosti();
            poleVzdalenostiSort();
                textOutPut.setText(textOutPut.getText() + "DONE");
            prepocitej = false;
            jButtonRestoreData.setEnabled(true);
            RecountIndicator.setBackground(new Color(0, 255, 0)); //cervena
        }

        //setNewClass vraci pocet chyb!!!
        pocetChyb = setNewClass();
        //exportFunction(jTableDataTraining, "");
        //exportFunction(jTableDataTesting, "");

        //UKLADANI DAT DO statistik
        Vector data = new Vector();
        data.add(statisticForm.getCisloTestu());
        data.add(jSliderKNNValue.getValue());
        data.add(jTableDataTesting.getRowCount());
        data.add(pocetChyb);

        float a = (float) (100.00 - pocetChyb * 100.00 / jTableDataTesting.getRowCount());
        Object aa = Round(a, 1);
        data.add(aa);
//        statisticForm.addToTree(jSliderKNNValue.getValue(), pocetChyb, jTableDataTesting.getRowCount(), "soubor.csv");
        JTable tabulka = statisticForm.getTabulka();
        addRowFunction(tabulka, data.toArray());

        //VYPIS do systémového řádku.
      if (!automat) {
        textOutPut.setText(textOutPut.getText() + "\nCLASSIFICATION for K = "+jSliderKNNValue.getValue());
        textOutPut.setText(textOutPut.getText() + "\n\tNumber of error: " + pocetChyb);
        textOutPut.setText(textOutPut.getText() + "\n\tNumber of rows: " + jTableDataTesting.getRowCount());
        textOutPut.setText(textOutPut.getText() + "\n\tPercentual success: " + aa);
      }
    }
    return pocetChyb;
}

private static float Round(float Rval, int Rpl) {
  float p = (float)Math.pow(10,Rpl);
  Rval = Rval * p;
  float tmp = Math.round(Rval);
  return (float)tmp/p;
}

private int setNewClass() {
    String KNN;
    String puvodni;
    int pocetChyb = 0;
    //pro každý řadek v testovací skupině
    if (!automat) textOutPut.setText(textOutPut.getText() + "\n");
    for (int i = 0; i < poleVzdalenosti.size(); i++) {
        ArrayList oneRow = poleVzdalenosti.get(i);
        KNN = getNearestClass(oneRow);
        puvodni = jTableDataTesting.getValueAt(i, 0).toString();
        if (!KNN.equals(puvodni)) {
            if (!automat) textOutPut.setText(textOutPut.getText() + "\nError on row: " + i + ".");
            jTableDataTesting.setValueAt("_Err "+puvodni+"->"+KNN, i, 0);
            pocetChyb++;
        }
    }
    return pocetChyb;
}

private String getNearestClass (ArrayList oneRow) {

    KClasses tridy = new KClasses();

    //NE SIZE() ale pocet radku v trenovaci skupine.. (dela check po kazdem pridani)
    // jelikoz mam pole řádků seřazené vyberu jen počet nejbližších sousedů dle zadané hodnoty K
    for (int i = 0; i < jSliderKNNValue.getValue(); i++) {
        //jednotlivé třídy uložím (tam se mi spočítá jejich výskyt)
        tridy.addClass(((Distance) oneRow.get(i)).getClassInRow());
    }

    //zde se vrátí ta která byla nejčastěji
    return tridy.getKNNClass();
}


private void jButtonRestoreDataActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonRestoreDataActionPerformed
    // TODO add your handling code here:
    restoreDataFunction(false);
    textOutPut.setCaretPosition(textOutPut.getText().length());
}//GEN-LAST:event_jButtonRestoreDataActionPerformed

private void restoreDataFunction(boolean zobrazZpravu) {
    int question = -1;

    //jen pokud UZ bylo neco ULOZENO tak se zobrazi hlaska o restore..
    //a nebyla zmenena struktura tabulky
    if (!puvodniTridy.isEmpty() && prepocitej == false) {
        if (optionsForm.isSetErrorShow() && zobrazZpravu) {
                question = JOptionPane.showConfirmDialog(null,
                "Do you want to restore previous data?",
                "INFORMATION",
                JOptionPane.YES_NO_OPTION,
                JOptionPane.INFORMATION_MESSAGE);
        }
        if (question == JOptionPane.YES_OPTION || !optionsForm.isSetErrorShow() || !zobrazZpravu) {
            for (int i = 0; i < jTableDataTesting.getRowCount(); i++) {                
                //ukladam jen ty ruzne (kvuli zachytavani, zbytecne dlouho)
                if (!jTableDataTesting.getValueAt(i, 0).equals(puvodniTridy.get(i))) {
                    jTableDataTesting.setValueAt(puvodniTridy.get(i), i, 0);
                }
            }
        }
    }
    //pokud se jeste nic nenacetlo
    //a zaroven NEZVOLIL RESTORE -> pak dojde k nacteni novych dat do puvodniTridy
    if (puvodniTridy.isEmpty() || question == JOptionPane.NO_OPTION || prepocitej == true) {
        puvodniTridy.clear();
        for (int i = 0; i < jTableDataTesting.getRowCount(); i++) {
            puvodniTridy.add(jTableDataTesting.getValueAt(i, 0));
        }
    }
}
/*
 * vraci false pri chybe
 * vraci true  pokud vse OK
 */
private boolean compareColumnType () {
    if (jTableHeadTesting.getColumnCount() == 0 || jTableHeadTraining.getColumnCount() == 0) {
        textOutPut.setText(textOutPut.getText() + "\nTraining or testing table is empty.");
        
        if (optionsForm.isSetErrorShow()) {
            JOptionPane.showMessageDialog(null,
                "Training or testing table is empty.",
                "Information",
                JOptionPane.INFORMATION_MESSAGE);
        }
        textOutPut.setCaretPosition(textOutPut.getText().length());
        return false;
    }
    if (jTableHeadTesting.getColumnCount() != jTableHeadTraining.getColumnCount()) {
        textOutPut.setText(textOutPut.getText() + "\nDifferent number of column in training and testing table.");
        
        if (optionsForm.isSetErrorShow()) {
            JOptionPane.showMessageDialog(null,
                "Different number of column!",
                "Error",
                JOptionPane.ERROR_MESSAGE);
        }
        textOutPut.setCaretPosition(textOutPut.getText().length());
        return false;
    }

    for (int i = 0; i < jTableHeadTesting.getColumnCount() && jTableHeadTesting.getRowCount() > 0 && jTableHeadTraining.getRowCount() > 0; i++) {
        if(jTableHeadTesting.getValueAt(0, i) != jTableHeadTraining.getValueAt(0, i)) {
            textOutPut.setText(textOutPut.getText() + "\nDifferent types in training and testing table.");
            if (optionsForm.isSetErrorShow()) {
                JOptionPane.showMessageDialog(null,
                    "Different types of column",
                    "Error",
                    JOptionPane.ERROR_MESSAGE);
            }
            textOutPut.setCaretPosition(textOutPut.getText().length());
            return false;
        }
    }

    //vsechny testy vporadku => true
    return true;
}
    
private void getVzdalenosti () {
    int i,j;
    double delka;
    ArrayList<Distance> pole;
    poleVzdalenosti.removeAll(poleVzdalenosti);

    for (j = 0; j < jTableDataTesting.getRowCount() && jTableDataTraining.getRowCount() > 0; j++) {
        pole = new ArrayList<Distance>();
        for (i = 0; i < jTableDataTraining.getRowCount(); i++) {
            delka = vzdalenost(i,j);

            //0 jelikoz trida CLASS je v prvnim sloupci.. :-)
            pole.add(new Distance(i, delka,jTableDataTraining.getValueAt(i, 0).toString()));
        }
        poleVzdalenosti.add(pole);
    }
}

private void poleVzdalenostiSort () {
    Object[] Pole;
    ArrayList aa;

    for (int i = 0; i < poleVzdalenosti.size(); i++) {
        Pole = poleVzdalenosti.get(i).toArray();
        Arrays.sort(Pole);
        aa = new ArrayList(Arrays.asList(Pole));
        poleVzdalenosti.set(i, aa);
    }
}

private void jButtonAddRowActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonAddRowActionPerformed
    JTable tabData = null;
    JTable tabHead = null;
    int aktivni = jTabbedPane.getSelectedIndex();
    if (aktivni == 0) {
        tabData = jTableDataTraining;
        tabHead = jTableHeadTraining;
    }
    else if (aktivni == 1) {
        tabData = jTableDataTesting;
        tabHead = jTableHeadTesting;
    }
    //pokud v tabulce neni zadny sloupec tak pridam alespon JEDEN kdyz chci vlozit radek
    if (tabData.getColumnCount() == 0) {
        addColumnFunction (tabData, tabHead, ""); //muze byt prazdny nazev sloupce
    }

    //PRIDAVANI RADKU!!!
    Object[] data = new Object[tabData.getColumnCount()];
    for (int i = 0; i < tabData.getColumnCount(); i++) {
        if (tabHead.getValueAt(0, i) == "Number") {
            data[i] = 0;
        }
        else {
            data[i] = "Text";
        }
    }
    addRowFunction (tabData, data);
    
    recountFunction(tabData);
}//GEN-LAST:event_jButtonAddRowActionPerformed

private void addRowFunction (JTable tabData, Object[] data) {
    tabData.clearSelection();
    ((MyDefaultTableModel)tabData.getModel()).addRow(data);
    if (!automat) textOutPut.setText(textOutPut.getText() + "\nOne row was added: \"" + (tabData.getRowCount()-1) + "\"..");
}

private void jButtonAddColumnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonAddColumnActionPerformed
    JTable tabData = null;
    JTable tabHead = null;
    int aktivni = jTabbedPane.getSelectedIndex();
    if (aktivni == 0) {
        tabData = jTableDataTraining;
        tabHead = jTableHeadTraining;
    }
    else if (aktivni == 1) {
        tabData = jTableDataTesting;
        tabHead = jTableHeadTesting;
    }
    if (tabData == null || tabHead == null) return;

    addColumnFunction (tabData, tabHead, ""); //muze byt prazdny nazev sloupce

    //recount
    recountFunction(tabData);
}//GEN-LAST:event_jButtonAddColumnActionPerformed


// nazev sloupce může být prázdny pak se doplní dle počtu sloupce
private void addColumnFunction (JTable tabData, JTable tabHead, String nazevSloupce) {
    tabData.clearSelection();

    //PRIDAVANI SLOUPCE s default hodnotou TEXT!!!!
    if (tabData != null || tabHead != null) {
        Vector text = new Vector();
        text.add("Text");
        Vector data = new Vector();
        for (int i = 0; i < tabData.getRowCount(); i++) {
            data.add("Text");
        }

        if (nazevSloupce.isEmpty()) nazevSloupce = "Column " + tabHead.getColumnCount();
        
        ((MyDefaultTableModel)tabHead.getModel()).addColumn(nazevSloupce, text);
        ((MyDefaultTableModel)tabData.getModel()).addColumn(nazevSloupce, data);
    }
    textOutPut.setText(textOutPut.getText() + "\nOne column was added: \"Column " + (tabData.getColumnCount()-1) + "\" with default values..");
}


private void jButtonDeleteRowActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonDeleteRowActionPerformed
    JTable tabData = null;
    int aktivni = jTabbedPane.getSelectedIndex();

    if (aktivni == 0)       { tabData = jTableDataTraining; }
    else if (aktivni == 1)  { tabData = jTableDataTesting; }
    if (tabData == null) return;

    int[] a = tabData.getSelectedRows();    
    //MAZU posledni nebo dle vyberu
    if (a.length == 0 && tabData.getRowCount() > 0) {
        deleteRowFunction (tabData, tabData.getRowCount()-1);
        textOutPut.setText(textOutPut.getText() + "\nLast row " + tabData.getRowCount() + " was deleted..");
    }
    else {
        for (int i = a.length-1; i >= 0; i--){
            deleteRowFunction (tabData, a[i]);
        }
        textOutPut.setText(textOutPut.getText() + "\n" + a.length + " number of row was deleted..");
    }
    if (tabData.getRowCount() == 0) textOutPut.setText(textOutPut.getText() + "\nTable does not have any row..");
    
    //recount
    recountFunction(tabData);
}//GEN-LAST:event_jButtonDeleteRowActionPerformed

private void deleteRowFunction (JTable tabData, int index) {
    tabData.clearSelection();
    ((MyDefaultTableModel)tabData.getModel()).removeRow(index);    
}

private void jButtonDeleteColumnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonDeleteColumnActionPerformed
    JTable tabData = null;
    JTable tabHead = null;
    int aktivni = jTabbedPane.getSelectedIndex();
    if (aktivni == 0) {
        tabData = jTableDataTraining;
        tabHead = jTableHeadTraining;
    }
    else if (aktivni == 1) {
        tabData = jTableDataTesting;
        tabHead = jTableHeadTesting;
    }
    if (tabData == null || tabHead == null) return;

    //mazu posledni nebo aktualni vybrany sloupec
    int a = tabData.getSelectedColumn();
    tabData.clearSelection();
    if(a == -1 && tabData.getColumnCount() > 0) {
        removeColumnAndData(tabData, tabData.getColumnCount()-1);
        removeColumnAndData(tabHead, tabHead.getColumnCount()-1);
        textOutPut.setText(textOutPut.getText() + "\nLast column " + tabData.getColumnCount() + " was deleted..");
    }
    else if (a >= 0) {
        //smazu konkretni sloupec (VZDY JEDEN)
        removeColumnAndData(tabData, a);
        removeColumnAndData(tabHead, a);
        textOutPut.setText(textOutPut.getText() + "\nColumn " + a + " was deleted...");
    }
    if(tabData.getColumnCount() == 0) {
        //smazat vsechny radky v modelu..
        textOutPut.setText(textOutPut.getText() + "\n  Table is empty..");
        clearALL(false);
    }

    //recount
    recountFunction(tabData);
}//GEN-LAST:event_jButtonDeleteColumnActionPerformed

private void removeColumnAndData(JTable tabulka, int vColIndex) {
    //MyDefaulTable je moje nova trida s metodou "getColumnIdentifiers" abych se dostal k modelu sloupce
    MyDefaultTableModel model = (MyDefaultTableModel)tabulka.getModel();

    TableColumn col = tabulka.getColumnModel().getColumn(vColIndex);
    int columnModelIndex = col.getModelIndex();
    Vector data = model.getDataVector();
    Vector colIds = model.getColumnIdentifiers();

    // Odstranim sloupec z tabulky
    tabulka.removeColumn(col);

    // Odstranim sloupec z hlavicky v modelu
    colIds.removeElementAt(columnModelIndex);

    // Remove the column data
    for (int r=0; r<data.size(); r++) {
        Vector row = (Vector)data.get(r);
        row.removeElementAt(columnModelIndex);
    }
    model.setDataVector(data, colIds);

    model.fireTableStructureChanged();
}

private void jButtonMoveDataActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonMoveDataActionPerformed
    JTable zdroj = null;
    JTable cil = null;
    int aktivni = jTabbedPane.getSelectedIndex();
    if (aktivni == 0) {
        zdroj = jTableDataTraining;
        cil = jTableDataTesting;
    }
    else if (aktivni == 1) {
        zdroj = jTableDataTesting;
        cil = jTableDataTraining;
    }
    if (zdroj == null || cil == null) return;

    //PRESUN Polozek    
    //Object poleRadku[] = (Object[]) (Object) zdroj.getSelectedRows();
    int [] poleRadku = zdroj.getSelectedRows();    
        textOutPut.setText(textOutPut.getText() + "\n" + poleRadku.length + " number of row will be moved.");
    automat = true;
    moveDataFunction (poleRadku, zdroj, cil);
    automat = false;
}//GEN-LAST:event_jButtonMoveDataActionPerformed

/*
 * Object je typu
 */
private void moveDataFunction (int[] poleRadku, JTable zdroj, JTable cil) {
    JTable cilHead = null;

    if (zdroj.getRowCount() == 0) {
        textOutPut.setText(textOutPut.getText() + "\nSource table is empty..");
        return;
    }    
    //pokud nic nevybral beru posledni radek..
    if (poleRadku.length == 0) {
        poleRadku = new int[1];
        poleRadku[0] = zdroj.getRowCount()-1;
    }
    
    Vector radky = ((MyDefaultTableModel)zdroj.getModel()).getDataVector();

    for (int i = poleRadku.length-1; i >= 0; i--) {
        try {
            Vector radek = (Vector)radky.elementAt((Integer)poleRadku[i]);

            //zkontrolovat počet sloupcu!!!!!
            //pokud ma MENE sloupcu nez kolik chci pridat, tak je pridam..
            if (cil.getColumnCount() < radek.size()) {
                //musim pridat k jiz importovanym radkum nejaky text,,, IMPORT je VETSI nez moje data
                if (cil.equals(jTableDataTraining)) cilHead = jTableHeadTraining;
                if (cil.equals(jTableDataTesting)) cilHead = jTableHeadTesting;
                if (cilHead == null) return; //pri chybe ukoncim

                for (int j = cil.getColumnCount(); j < radek.size() ; j++) {
                    addColumnFunction(cil, cilHead, "");
                }
            }
            //pokud ma to co pridavam mene sloupcu nez vysledna tabulka, tak doplnim do radku 0 nebo Text
            else if (radek.size() < cil.getColumnCount()) {
                for (int j = radek.size(); j < cil.getColumnCount(); j++) {
                    if (cil.getValueAt(0, j).equals("Number")) {
                        radek.add(0); // Doplnim radek NULAMA kdyz sNumber
                    }
                    else {
                        radek.add("Text"); // Doplnim radek Textem kdyz Text
                    }

                }
            }
            //pokud maji stejne NORMALNE PRIDAM
            //textOutPut.setText(textOutPut.getText() + "\n\tPRESOUVANI RADKU..");
            addRowFunction(cil, radek.toArray());
            deleteRowFunction(zdroj, (Integer)poleRadku[i]);

        } catch (ArrayIndexOutOfBoundsException a) {
            // Index neexistoval.. 
            continue;
        }
    }
    recountFunction (zdroj);
    textOutPut.setText(textOutPut.getText() + " - source table..");
    recountFunction (cil);
    textOutPut.setText(textOutPut.getText() + " - target table..");
    textOutPut.setCaretPosition(textOutPut.getText().length());
}

private void jButtonRandomMoveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonRandomMoveActionPerformed
    JTable zdroj = null;
    JTable cil = null;
    int aktivni = jTabbedPane.getSelectedIndex();
    if (aktivni == 0) {
        zdroj = jTableDataTraining;
        cil  = jTableDataTesting;
    }
    else if (aktivni == 1) {
        zdroj = jTableDataTesting;
        cil  = jTableDataTraining;
    }
    if (zdroj == null || cil == null) return;

    Random generator = new Random();
    int a = (Integer) jSpinnerRandomMove.getValue();

    int pocet = zdroj.getRowCount() * a / 100;
    //alespon JEDEN se presune
    if (pocet <= 0) {
        if (optionsForm.isSetErrorShow()) {
            JOptionPane.showMessageDialog(null, "Percentual result of row is smaller than 0. Moving action was not finished.\nPlease increase the number of percentual row for moving.");
        }
        textOutPut.setText(textOutPut.getText() + "\nPercentual result of row is smaller than 0. Moving action was not finished.");
        textOutPut.setCaretPosition(textOutPut.getText().length());
        return;
    }

    int[] poleRadku = new int[pocet];
    int i=0;
    while (pocet != i) {
        poleRadku[i] = generator.nextInt(zdroj.getRowCount());
        i++;
    }
    Arrays.sort(poleRadku);

    automat = true;
    moveDataFunction(poleRadku, zdroj, cil);
    automat = false;
        textOutPut.setText(textOutPut.getText() + "\nRandom select " + pocet + " of row from table ("+a+"%)");
    recountFunction (zdroj);
        textOutPut.setText(textOutPut.getText() + " - source table..");
    recountFunction (cil);
        textOutPut.setText(textOutPut.getText() + " - target table..");
        textOutPut.setCaretPosition(textOutPut.getText().length());
}//GEN-LAST:event_jButtonRandomMoveActionPerformed

private void jButtonStatisticActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonStatisticActionPerformed
    statisticForm.setLocationRelativeTo(null);
    statisticForm.setVisible(true);
}//GEN-LAST:event_jButtonStatisticActionPerformed

private void jMenuOptionsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuOptionsActionPerformed
    optionsForm.setLocationRelativeTo(null);
    optionsForm.setVisible(true);
}//GEN-LAST:event_jMenuOptionsActionPerformed

private void jMenuItemAboutActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemAboutActionPerformed
    AboutBox about = new AboutBox();
    about.setLocationRelativeTo(null);
    about.setVisible(true);
}//GEN-LAST:event_jMenuItemAboutActionPerformed

private void jButtonRecountAllActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonRecountAllActionPerformed
    recountFunction (jTableDataTraining);
    textOutPut.setText(textOutPut.getText() + " - training table..");
    recountFunction (jTableDataTesting);
    textOutPut.setText(textOutPut.getText() + " - testing table..");
}//GEN-LAST:event_jButtonRecountAllActionPerformed

private void jMenuExportTrainingActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuExportTrainingActionPerformed
    // TODO add your handling code here:
    exportFunction(jTableDataTraining, "");
}//GEN-LAST:event_jMenuExportTrainingActionPerformed

private void jMenuExportTestingActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuExportTestingActionPerformed
    // TODO add your handling code here:
    exportFunction(jTableDataTesting, "");
}//GEN-LAST:event_jMenuExportTestingActionPerformed

private void jMenuExportStatisticsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuExportStatisticsActionPerformed
    // TODO add your handling code here:    
    JTable tabulka = statisticForm.getTabulka();
    exportFunction(tabulka, "");
}//GEN-LAST:event_jMenuExportStatisticsActionPerformed

//vraci soubor, ktery byl ulozen a ktery NEEXISTOVAL!!
//osetri pokud nazev jiz existoval , vstup nazev = "" muze byt prazdny
//vraci null při chybě!!
private File exportFunction (JTable tabData, String nazev) {
    File fExport = null;
    
    if(nazev.isEmpty()) {
        if(tabData.equals(jTableDataTraining)) nazev = "training";
        else if(tabData.equals(jTableDataTesting)) nazev = "testing";
        else nazev = "export";
    }

    if (tabData.getRowCount() == 0 || tabData == null) {
        textOutPut.setText(textOutPut.getText() + "\nTable is empty - export was stopped..");
        if (optionsForm.isSetErrorShow()) {
            JOptionPane.showMessageDialog(null, "Table is empty - export was stopped.");
        }
        textOutPut.setCaretPosition(textOutPut.getText().length());
        return null;
    }

    try {
        //ziska cestu k programu..
        String path = new java.io.File(".").getCanonicalPath();
        String sNumber = "";
        boolean exists = true;
        int cislo = 1;

        fExport = new File(path + "\\" + nazev + sNumber + ".csv");
        exists = fExport.exists();
        while (exists){
            sNumber = Integer.toString(cislo);
            fExport = new File(path + "\\" + nazev + sNumber + ".csv");
            exists = fExport.exists();
            cislo++;
        }

        exportTable(tabData, fExport);
                
        if (optionsForm.isSetErrorShow()) {
            JOptionPane.showMessageDialog(null, "File has been exported: \n" + fExport.getPath());
        }
        textOutPut.setText(textOutPut.getText() + "\nFile has been exported:\n" + fExport.getPath());

    } catch (IOException ex) {
        //Logger.getLogger(knnForm.class.getName()).log(Level.SEVERE, null, ex);
    }
    textOutPut.setCaretPosition(textOutPut.getText().length());
    
    return fExport;
}

private void exportTable(JTable table, File file) throws IOException {
    TableModel model = table.getModel();
    FileWriter out = new FileWriter(file);
    String separator = optionsForm.getSeparator();

    for(int i=0; i < model.getColumnCount(); i++) {
        out.write(model.getColumnName(i) + separator);
    }
    out.write("\n");
    for(int i=0; i< model.getRowCount(); i++) {
        for(int j=0; j < model.getColumnCount(); j++) {
            out.write(model.getValueAt(i,j).toString()+ separator);
        }
        out.write("\n");
    }
    out.close();
}

private void recountFunction (JTable tabulka) {
    prepocitej = true;
    RecountIndicator.setBackground(new Color(255, 0, 0)); //cervena

    //byla zmenena struktura tabulky -> restore button neni aktivni
    jButtonRestoreData.setEnabled(false);


    //pokud jsem v jTableTraining nastava zmena posouvatka a max generovane hodnoty
    if (tabulka.equals(jTableDataTraining)) {
        setSliderMaxValue();
        optionsForm.setZarazkaKNN(tabulka.getRowCount());
    }

    getNewMinMax();
    
    if(((tabulka.equals(jTableDataTraining)))) getAndSetHeadType(tabulka, jTableHeadTraining);
    else if(tabulka.equals(jTableDataTesting)) getAndSetHeadType(tabulka, jTableHeadTesting);

    textOutPut.setText(textOutPut.getText() + "\nRecount function (MINMAX, HeadType, setSlider, OptionsForm, prepocitej, recountIndicator, restore button)");
    textOutPut.setCaretPosition(textOutPut.getText().length());    
}

private double vzdalenost(int rowTrain, int rowTest) {
    double sumVzdalenosti = 0, vzdalenost = 0;
    int i;
    double x, y, xNor, yNor;
    String sTrain, sTest;

    for (i = 1; i < jTableDataTesting.getColumnCount(); i++) {
        //delam sumy pres vsechny atributy (dimenze) SUMA ve vzorci

        sTrain = (jTableDataTraining.getValueAt(rowTrain, i)).toString();
        sTest = (jTableDataTesting.getValueAt(rowTest, i)).toString();

        try
        {
            x = Double.parseDouble(sTrain);
            y = Double.parseDouble(sTest);

            //NORMALIZACE
            xNor = (x - poleMinMax.get(i).getMin()) / (poleMinMax.get(i).getMax() - poleMinMax.get(i).getMin());
            yNor = (y - poleMinMax.get(i).getMin()) / (poleMinMax.get(i).getMax() - poleMinMax.get(i).getMin());
            vzdalenost = (xNor - yNor) * (xNor - yNor);

        } catch(NumberFormatException e) {
            //zpracovani toho ze NENI INT ale string 0 ... 1
            //pokud sTest == sTrain pak vzdalenost je 0 jinak maximalni = 1
            if (sTest.equals(sTrain)) {
                vzdalenost = 0;
            }
            else vzdalenost = 1;
        }
        sumVzdalenosti += vzdalenost;
    }
    sumVzdalenosti = Math.sqrt(sumVzdalenosti);
    return sumVzdalenosti;
}

private void exitForm () {
    System.exit(0);
}

public static void main(String args[]) {
        knnForm knnForm = new knnForm();
        knnForm.setLocationRelativeTo(null);        
        knnForm.setExtendedState(JFrame.MAXIMIZED_BOTH);  //Maximizing the frame        
        knnForm.setVisible(true);
        knnForm.textOutPut.setText("Application started...");
}


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel RecountIndicator;
    private javax.swing.JButton jButtonAddColumn;
    private javax.swing.JButton jButtonAddRow;
    private javax.swing.JButton jButtonAutomatic;
    private javax.swing.JButton jButtonClear;
    private javax.swing.JButton jButtonClose;
    private javax.swing.JButton jButtonDeleteAll;
    private javax.swing.JButton jButtonDeleteColumn;
    private javax.swing.JButton jButtonDeleteRow;
    private javax.swing.JButton jButtonKNN;
    private javax.swing.JButton jButtonMoveData;
    private javax.swing.JButton jButtonRandomMove;
    private javax.swing.JButton jButtonRecountAll;
    private javax.swing.JButton jButtonRestoreData;
    private javax.swing.JButton jButtonStatistic;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabelKNN;
    private javax.swing.JLabel jLabelRandomMove;
    private javax.swing.JMenu jMenuAbout;
    private javax.swing.JMenuBar jMenuBar;
    private javax.swing.JMenuItem jMenuExit;
    private javax.swing.JMenuItem jMenuExportStatistics;
    private javax.swing.JMenuItem jMenuExportTesting;
    private javax.swing.JMenuItem jMenuExportTraining;
    private javax.swing.JMenu jMenuFile;
    private javax.swing.JMenu jMenuFileExport;
    private javax.swing.JMenu jMenuFileImport;
    private javax.swing.JMenuItem jMenuImportTesting;
    private javax.swing.JMenuItem jMenuImportTraining;
    private javax.swing.JMenuItem jMenuItemAbout;
    private javax.swing.JMenuItem jMenuOptions;
    private javax.swing.JMenu jMenuTools;
    private javax.swing.JPanel jPanelForm;
    private javax.swing.JPanel jPanelHead;
    private javax.swing.JPanel jPanelRightButtons;
    private javax.swing.JPanel jPanelTesting;
    private javax.swing.JPanel jPanelTraining;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSlider jSliderKNNValue;
    private javax.swing.JSpinner jSpinnerRandomMove;
    private javax.swing.JTabbedPane jTabbedPane;
    private javax.swing.JTable jTableDataTesting;
    private javax.swing.JTable jTableDataTraining;
    private javax.swing.JTable jTableHeadTesting;
    private javax.swing.JTable jTableHeadTraining;
    private java.awt.Label label1;
    private java.awt.TextArea textOutPut;
    // End of variables declaration//GEN-END:variables
    
}
